; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    dcmp PROTO :DWORD,:DWORD,:DWORD

    .data
    align 4
      item1 db "xxxxxx",0
    align 4
      item2 db "xxxxxxxxxxxxxxxxx",0
    align 4
      item3 db "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx",0
    align 4
      item4 db "xxxxxxxxxxxxxxxxxxxxxxxxxyxxxxxxxxxxxxxxxxxxxxxxx",0

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    print "Testing correct return values",13,10

    invoke dcmp,ADDR item3,ADDR item4,25
    print str$(eax),13,10

    invoke dcmp,ADDR item3,ADDR item4,39
    print str$(eax),13,10,13,10

    print "Timings",13,10,13,10

    push esi

    mov esi, 10000000

    invoke GetTickCount
    push eax
  @@:
    invoke dcmp,ADDR item1,ADDR item4,LENGTHOF item1
    invoke dcmp,ADDR item2,ADDR item4,LENGTHOF item2
    invoke dcmp,ADDR item3,ADDR item4,LENGTHOF item3
    invoke dcmp,ADDR item4,ADDR item4,LENGTHOF item4
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," dcmp timing",13,10

    mov esi, 10000000
    invoke GetTickCount
    push eax
  @@:
    invoke szCmp,ADDR item1,ADDR item4
    invoke szCmp,ADDR item2,ADDR item4
    invoke szCmp,ADDR item3,ADDR item4
    invoke szCmp,ADDR item4,ADDR item4
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," szCmp timing",13,10

    pop esi

    ret

main endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

dcmp proc src:DWORD,dst:DWORD,ln:DWORD

    mov eax, [esp+4]        ; src
    mov edx, [esp+8]        ; dst
    mov ecx, [esp+12]       ; ln

    shr ecx, 3

    push ebx
    push esi
    push edi
    push ebp

    cmp DWORD PTR [esp+12+16], 8    ; if length < 8
    jl tlin

  @@:
  REPEAT 3
    mov ebx, [eax]
    mov esi, [eax+4]
    mov edi, [edx]
    mov ebp, [edx+4]
    cmp ebx, edi
    jne fail
    cmp esi, ebp
    jne fail
    add eax, 8
    add edx, 8
    sub ecx, 1
    jz tail
  ENDM

    mov ebx, [eax]
    mov esi, [eax+4]
    mov edi, [edx]
    mov ebp, [edx+4]
    cmp ebx, edi
    jne fail
    cmp esi, ebp
    jne fail
    add eax, 8
    add edx, 8
    sub ecx, 1
    jnz @B

  tail:
    mov ecx, [esp+12+16]    ; reload length
    and ecx, 4
    jz ok

  tlin:
    xor esi, esi

  @@:
    movzx ebx, BYTE PTR [eax+esi]
    cmp bl, [edx+esi]
    jne fail
    add esi, 1
    sub ecx, 1
    jnz @B

  ok:
    mov eax, 1          ; return NON-ZERO on match
    pop ebp
    pop edi
    pop esi
    pop ebx
    ret 12

  fail:
    xor eax, eax        ; return ZERO on no match
    pop ebp
    pop edi
    pop esi
    pop ebx
    ret 12

dcmp endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

end start




















